
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C12E4F  ; location in v1.0
;org $C12E4C  ; location in v1.1
;org $C12E27  ; location in SFC version
REPLACE1:  ; adjusted branch #1
C12E4F:	BRA reset_rotation
;C12E4F:	BRA exit

org $C12E5C  ; location in v1.0
;org $C12E59  ; location in v1.1
;org $C12E34  ; location in SFC version
REPLACE2:  ; adjusted branch #2
C12E5C:	BRA reset_rotation
;C12E5C:	BRA exit

org $C12E69  ; location in v1.0
;org $C12E66  ; location in v1.1
;org $C12E41  ; location in SFC version
REPLACE3:  ; adjusted branch #3
C12E69:	BRA reset_rotation
;C12E69:	BRA exit

C12E6B:	LDA $2EA9,Y  ; get current outline rotation

main_loop:
C12E6E:	BIT $38  ; check against current status
C12E70:	BNE set_colour  ; branch if a match was found
C12E72:	LSR A  ; check next status
C12E73:	ADC #$00  ; maintain wait bit
C12E75:	STA $2EA9,Y  ; update outline colour rotation
C12E78:	CMP #$04  ; loop over 6 statuses
C12E7A:	BCS main_loop

reset_rotation:
C12E7C:	LDA #$80  ; no match found, reset to Rflect

update_rotation:
C12E7E:	STA $2EA9,Y
C12E81:	RTS

set_colour:
C12E82:	AND #$FC  ; clear wait bit
C12E84:	JSR $1A0F  ; v1.0 or v1.1
;C12E84:	JSR $19E7  ; SFC only
C12E87:	LDA outline_color_table,X  ; get outline colour

outline_color_table:
C12E8B:	BRA outline_control  ; implement

DB $04  ; Slow
DB $03  ; Haste
DB $07  ; Stop
DB $02  ; Shell
DB $01  ; Safe
DB $00  ; Rflect

rotate_outline:
C12E93:	LDA $2EA9,Y  ; current outline colour rotation

rotation_loop:
C12E96:	LSR A  ; move one step forward
C12E97: BCS reset_rotation  ; if wait bit set, clear it, reset and exit
C12E99:	AND #$FC  ; keep 6 bits
C12E9B:	BEQ reset_rotation  ; if all cleared, reset and exit

check_status:
C12E9D:	BIT $38  ; check current status
C12E9F:	BEQ rotation_loop  ; loop until match found
C12EA1:	BRA update_rotation  ; update outline rotation

C12EA3:	NOP
C12EA4:	NOP
C12EA5:	NOP
C12EA6:	NOP
C12EA7:	NOP
C12EA8:	NOP
C12EA9:	NOP
C12EAA:	NOP
C12EAB:	NOP
C12EAC:	NOP
C12EAD:	NOP
C12EAE:	NOP
C12EAF:	NOP
C12EB0:	NOP
C12EB1:	NOP
C12EB2:	NOP
C12EB3:	NOP

;	LDA $38  ; if reversing, comment out everything above...
;	BPL check_safe  ; ...except the three adjusted branches...
;	TDC  ; ...and uncomment everything until next org...
;	JSR outline_control  ; ...except the RTS and label right before that
;	BRA exit

;check_safe:
;	AND #$40
;	BEQ check_shell
;	LDA #$01
;	JSR outline_control
;	BRA exit

;check_shell:
;	LDA $38
;	AND #$20
;	BEQ check_stop
;	LDA #$02
;	JSR outline_control
;	BRA exit

;check_stop:
;	LDA $38
;	AND #$10
;	BEQ check_haste
;	LDA #$07
;	JSR outline_control
;	BRA exit

;check_haste:
;	LDA $38
;	AND #$08
;	BEQ check_slow
;	LDA #$03
;	JSR outline_control
;	BRA exit

;check_slow:
;	LDA $38
;	AND #$04
;	BEQ exit
;	LDA #$04
;	JSR outline_control
;	BRA exit

exit:
C12EB4:	RTS

org $C12EC3  ; location in v1.0
;org $C12EC0  ; location in v1.1
;org $C12E9B  ; location in SFC version
outline_control:
C12EC3:	PHA
C12EC4:	LDA $0E
C12EC6:	STA $2C
C12EC8:	PLA
C12EC9:	PHA
C12ECA:	LDA $2C
C12ECC:	AND #$03
C12ECE:	TAX
C12ECF:	LDA $C2E3AA,X  ; v1.0 or v1.1
;C12ECF:	LDA $C2E36C,X  ; SFC only
C12ED3:	CLC
C12ED4:	ADC $2C
C12ED6:	STA $36
;REMOVED1:
;	AND #$40
;	BEQ fade_increasing
;	LDA $36
;	AND #$3C
;	LSR A
;	STA $2C
;	LDA #$1F
;	SEC
;	SBC $2C
;	STA $2C
;	STZ $2D
;	BRA continue_control
;	LDA $36
C12ED8:	AND #$3C
C12EDA:	LSR A
C12EDB:	STA $2C
C12EDD:	STZ $2D
	LDA $36
	ASL A
	ASL A
	BCC colour_transition
	LDA #$1F
	SBC $2C
	STA $2C

colour_transition:
	LDA $2C
	CMP #$1F
	BNE continue_control
	JSR rotate_outline
	BRA continue_control
	NOP

org $C2307D  ; location in v1.0 or v1.1
;org $C23078  ; location in SFC version
C2307D:	PHX  ; preserve party member index
;REMOVED2:	PHA
C2307E:	LDA $FE  ; get row
C23080:	STA $3AA1,X  ; save to special properties
C23083:	LDA $3ED9,X  ; preserve special sprite
C23086:	PHA
REPLACE1:  ; LDA $??,S replacement
C23087:	LDA $05,S  ; get loop variable
;C23087:	LDA $06,S
C23089:	STA $3ED9,X  ; save to roster position
C2308C:	TDC
C2308D:	TXA
C2308E:	ASL A
C2308F:	ASL A
C23090:	ASL A
C23091:	ASL A
C23092:	TAX
REPLACE2:  ; three instructions replace three instructions
C23093:	LDA #$06  ; 7-iteration loop
C23095:	STA $FE  ; initialize loop counter
C23097:	PHY  ; preserve Y-loop index
;C23093:	PLA
;C23095:	CMP #$FF
;C23097:	BNE set_battle_sprite

display_init_loop:
C23098:	LDA $1601,Y  ; get normal sprite & name characters

set_battle_sprite:
C2309B:	STA $2EAE,X  ; store to display variables
REPLACE3:  ; mass replacement, nothing after this
C2309E:	INX
C2309F:	INY
C230A0:	DEC $FE
C230A2:	BPL display_init_loop
C230A4:	PLY  ; restore Y-loop index
C230A5:	PLA  ; restore special sprite
C230A6:	CMP #$FF  ; is special sprite null?
C230A8: BEQ init_outline_rotation  ; if not...
C230AA:	STA $2EA7,X  ; ...overwrite sprite

init_outline_rotation:
C230AD:	LDA #$81  ; Rflect status, wait bit
C230AF:	STA $2EA2,X  ; initialize outline rotation
C230B2:	LDA $03,S  ; get character ID
C230B4:	STA $2EBF,X  ; save it
C230B7:	CMP #$0E  ; is it Banon or higher?
C230B9:	REP #$20  ; 16-bit A
C230BB:	TAX  ; move to X

;	TDC
;	PLA
;	STA $2EC6,X
;	CMP #$0E
;	REP #$20
;	PHA
;	LDA $1602,Y
;	STA $2EAF,X
;	LDA $1604,Y
;	STA $2EB1,X
;	LDA $1606,Y
;	STA $2EB3,X
;	PLX